<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               :upload-after="uploadAfter"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.versionupgrade_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/platform/versionupgrade";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "主键ID",
              prop: "id",
              hide: true,
              display: false,
            },
            {
              label: "版本编号",
              prop: "versionCode",
              type: "number",
              width: 80,
              rules: [{
                required: true,
                message: "请输入版本编号",
                trigger: "blur"
              }]
            },
            {
              label: "版本号",
              prop: "versionName",
              width: 80,
              rules: [{
                required: true,
                message: "请输入版本号",
                trigger: "blur"
              }]
            },
            {
              label: "是否启用",
              prop: "statusDisplayName",
              display: false,
              width: 100,
            },
            {
              label: "升级类型",
              prop: "typeDisplayName",
              display: false,
              width: 100,
              rules: [{
                required: true,
                message: "请输入升级类型",
                trigger: "blur"
              }]
            },
            {
              label: "升级类型",
              prop: "type",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=upgrade_type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              rules: [{
                required: true,
                message: "请选择升级类型",
                trigger: "blur"
              }]
            },
            {
              label: "是否启用",
              prop: "status",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              addDisplay: false,
              rules: [{
                required: true,
                message: "请选择是否启用",
                trigger: "blur"
              }]
            },
            {
              label: '包路径',
              prop: 'apkUrl',
              span: 24,
              overHidden: true,
              addDisplay: true,
              editDisplay: true,
            },
            {
              label: "更新内容",
              prop: "content",
              type: "textarea",
              span: 24,
              overHidden: true,
              rules: [{
                required: true,
                message: "请输入更新内容",
                trigger: "blur"
              }]
            },
            {
              label: '安装包',
              prop: 'fileUrl',
              type: 'upload',
              drag: true,
              listType: 'text',
              loadText: '模板上传中，请稍等',
              span: 24,
              viewDisplay: false,
              hide: true,
              propsHttp: {
                res: 'data',
                url: 'link',
              },
              action: "/api/platform/versionupgrade/uploadApk"
            },
            {
              label: "创建时间",
              prop: "createTime",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入",
                trigger: "blur"
              }]
            },
            {
              label: "更新时间",
              prop: "updateTime",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入更新时间",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.versionupgrade_add, false),
          viewBtn: this.vaildData(this.permission.versionupgrade_view, false),
          delBtn: this.vaildData(this.permission.versionupgrade_delete, false),
          editBtn: this.vaildData(this.permission.versionupgrade_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        if(row.fileUrl && row.fileUrl.length == 1){
          row.apkUrl = row.fileUrl[0]["value"];
        }
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      uploadAfter(res, done, loading, column) {
        this.form.apkUrl = res.link;
        done()
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
